/*
 * Copyright 1995 untill 2011 RMIB (see the readme for contact information)
 *
 * This file is part of libxrit
 *
 * libxrit is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libxrit is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with libxrit.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "rmibsmalllib.h"


/*  BATS LIBRARY GLOBAL VARIABLE */
/*  USER SHOULD PUT INTO COMMENT NON RELEVANT VARIABLES */

/* global variable for error management (lib_util/src/err_mng.c) */

#ifndef NOMAGICK

struct MAGICK_image {
	Image *image;
};

static int4 MagInit = 0;
static void ErrorMagick(const ExceptionType, const char *, const char *);

#define MagJOE(e) { CatchException(e); JOE; }
#define MJOE MagJOE(&MagEx)

#define InitMag { \
	if (!MagInit) { \
		const int4 ARGB = 0x41524742; /* BE "ARGB" */ \
		InitializeMagick(NULL); \
		SetErrorHandler(ErrorMagick); \
		memcpy(channels[0], &ARGB, sizeof ARGB); \
		MagInit = 1; } \
 }
#endif

/*
static char channels[][sizeof (int4) + 1] = { "", "I" };
*/

/* not needed ?? with new version LG
static int4 rof_compress_flag = COMP_NONE;
static int4 jpeg_quality_level = 75;
*/

/* not needed with new version LG
struct _Err Err = { 0, 0, 0 };
int ErrCount = 0;
int WarnCount = 0;

static int WarnVerbose = 1;
static int ErrVerbose = 1;

static int ErrLine = -1;

#define ERROR_MSG_LEN   256
static char ErrMsg[ERROR_MSG_LEN] = "";

#define ERROR_FILE_LEN  256
static char ErrFileName[ERROR_FILE_LEN] = "";
static FILE *ErrFile = NULL;

*/
/* LG
 global variable for colormap management (lib_plot/src/colormap.c)

char *color_names[NB_COLORS] = {
        "black", "white", "red", "green", "blue",
        "magenta", "cyan", "light blue", "orange", "brown",
        "light gray", "maroon", "medium blue", "pink", "salmon",
        "sky blue", "coral", "spring green", "medium slate blue", "gold",
        "gray", "khaki", "violet", "forest green"
};


*/

/* global variable for command line management (lib_util/src/comline.c)*/

/*
static SM_strings *global_comline = NULL;
static SM_strings *global_comline_complete = NULL;
*/



/* global variable for random number generation (lib_math/src/math_ut.c) */

long randseed = 3L;


int4 bats_display_byte_swap;


/* For LA_PreciseSunDirection( t) */
/* LG
typedef void (*SunCalculus) (double, double *, double *, double *);
*/

#define NUM_BRET_COEFF 50

/* not needed anymore LG
static const int4 l_coeff[NUM_BRET_COEFF] = {
	403406,
	195207,
	119433,
	112392,
	3891,
	2819,
	1721,
	0,
	660,
	350,
	334,
	314,
	268,
	242,
	234,
	158,
	132,
	129,
	114,
	99,
	93,
	86,
	78,
	72,
	68,
	64,
	46,
	38,
	37,
	32,
	29,
	28,
	27,
	27,
	25,
	24,
	21,
	21,
	20,
	18,
	17,
	14,
	13,
	13,
	13,
	12,
	10,
	10,
	10,
	10
};

static const int4 r_coeff[NUM_BRET_COEFF] = {
	0,
	-97597,
	-59715,
	-56188,
	-1556,
	-1126,
	-861,
	941,
	-264,
	-163,
	0,
	309,
	-158,
	0,
	-54,
	0,
	-93,
	-20,
	0,
	-47,
	0,
	0,
	-33,
	-32,
	0,
	-10,
	-16,
	0,
	0,
	-24,
	-13,
	0,
	-9,
	0,
	-17,
	-11,
	0,
	31,
	-10,
	0,
	-12,
	0,
	-5,
	0,
	0,
	0,
	0,
	0,
	0,
	-9
};

static const double a_coeff[NUM_BRET_COEFF] = {
	4.721964,
	5.937458,
	1.115589,
	5.781616,
	5.5474,
	1.5120,
	4.1897,
	1.163,
	5.415,
	4.315,
	4.553,
	5.198,
	5.989,
	2.911,
	1.423,
	0.061,
	2.317,
	3.193,
	2.828,
	0.52,
	4.65,
	4.35,
	2.75,
	4.50,
	3.23,
	1.22,
	0.14,
	3.44,
	4.37,
	1.14,
	2.84,
	5.96,
	5.09,
	1.72,
	2.56,
	1.92,
	0.09,
	5.98,
	4.03,
	4.27,
	0.79,
	4.24,
	2.01,
	2.65,
	4.98,
	0.93,
	2.21,
	3.59,
	1.50,
	2.55
};

static const double n_coeff[NUM_BRET_COEFF] = {
	1.621043,
	62830.348067,
	62830.821524,
	62829.634302,
	125660.5691,
	125660.9845,
	62832.4766,
	0.813,
	125659.310,
	57533.850,
	-33.931,
	777137.715,
	78604.191,
	5.412,
	39302.098,
	-34.861,
	115067.698,
	15774.337,
	5296.670,
	58849.27,
	5296.11,
	-3980.70,
	52237.69,
	55076.47,
	261.08,
	15773.85,
	188491.03,
	-7756.55,
	264.89,
	117906.27,
	55075.75,
	-7961.39,
	188489.81,
	2132.19,
	109771.03,
	54868.56,
	25443.93,
	-55731.43,
	60697.74,
	2132.79,
	109771.63,
	-7752.82,
	188491.91,
	207.81,
	29424.63,
	-7.99,
	46941.14,
	-68.29,
	21463.25,
	157208.40
};

*/

#ifndef ROUND
#ifdef FASTROUND
#define ROUND(a) ((a) < 0. ? (int4) ((a) - .5) : (int4) ((a) + .5))
#endif
#endif



struct _Err Err = { 0, 0, 0 };

int ErrCount = 0;

static FILE *ErrFile = NULL;

static char ErrFileName[ERROR_FILE_LEN] = "";

static int ErrLine = -1;

static char ErrMsg[ERROR_MSG_LEN] = "";

static int ErrVerbose = 1;

static int4 first = 1;

double vz[NVZ] = { 0, 15., 25., 35., 45., 55., 65., 75., 90. };

int WarnCount = 0;

static int WarnVerbose = 1;

static SM_strings *global_comline = NULL; /* stop at the first -- */

static SM_strings *global_comline_complete = NULL; /* ignore the -- */

CP_dataset *dst = NULL;			/*Object 4 */

int4 bats_display_byte_swap = 0;

int4 nbre_iter_test, x_dim, nb_classes;

int4 nbre_iter_test, x_dim, nb_classes;

int4 nbre_iter_test, x_dim, nb_classes;

 static void CloseErrFile(void);
 static void OpenErrFile(void);
 static int descend(const char *name, const struct stat *ptr, int flag, struct FTW *ftw_s);
 static SM_strings *_FM_ScanDirectory(const char *directory, int4 mode);
/*  BATS LIBRARY SOURCE CODE */

void *allocate(size_t size)
{
	void *ptr = NULL;

	ERROR_IF_M(size > MAX_UINT(size_t), PARAMETER_ERR);
	TERMINATE_IF(size == 0);

	ERROR_IF_M1((ptr = calloc(size, 1)) == NULL, ALLOCATION_ERR"(size %d)", size);

	ERROR_HANDLER("allocate");
	RETURN(ptr);
}

int4 ByteSex(void)
{
	union {
		int i;
		char c;
	} a;

	a.i = 1;
	if (a.c)
		return LU_LITTLE_ENDIAN;
	else
		return LU_BIG_ENDIAN;
}

void deallocate(void *ptr)
{
	TERMINATE_IF(ptr == NULL);
	free(ptr);
    /*printf("free %p\n",ptr);*/
	ERROR_HANDLER("deallocate");
	ERROR_END;
}

int4 CL_InitFlag(void)
{

  return (global_comline!=NULL || global_comline_complete!=NULL);
}

static void CloseErrFile(void)
{
	if (ErrFile != stdout && ErrFile != stderr && ErrFile != NULL)
		fclose(ErrFile);
	ErrFile = NULL;
}

int4 SizeOf(int4 type)
{
int4 size = -1;

	switch (type) {
	case BIT:
		size = sizeof (bit);
		break;
	case U_CHAR:
		size = sizeof (u_c);
		break;
	case CHAR:
		size = sizeof (s_c);
		break;
	case U_INT1:
		size = sizeof (u_int1);
		break;
	case INT1:
		size = sizeof (int1);
		break;
	case U_INT2:
		size = sizeof (u_int2);
		break;
	case INT2:
		size = sizeof (int2);
		break;
	case RGBA:
	case U_INT4:
		size = sizeof (u_int4);
		break;
	case INT4:
		size = sizeof (int4);
		break;
	case U_INT_8:
		size = sizeof (u_int_8);
		break;
	case INT_8:
		size = sizeof (int_8);
		break;
	case FLOAT:
		size = sizeof (float4);
		break;
	case DOUBLE:
		size = sizeof (double);
		break;
	case P2VOID:
		size = sizeof (void *);
		break;
	default:
		ERROR_M1("Bad type (%d)", type);
	}

	ERROR_HANDLER("SizeOf");
	RETURN(size);
}

void convert_discrete(void *dst, int4 dtype, const void *src, int4 stype, size_t nelem, double quanta, double offset)
{
	size_t          len;
	char           *end;

	len = nelem * SizeOf(dtype);
	if (dtype == stype)
	{
		memcpy(dst, src, len);
		return;
	}

	ERROR_IF_V(dtype == RGBA && stype == RGBA);
	ERROR_IF_V(dtype == RGBA);
	ERROR_IF_V(stype == RGBA);

	end = (char *)dst + len;

	_SWITCH2(dtype, stype, _SWITCH1, _CONVERT_DISCRETE);
	ERROR_HANDLER("convert_discrete");
	ERROR_END;
}

void convert_discrete_error(void *dst, int4 dtype, const void *src, int4 stype, size_t nelem, double quanta, double offset,
					  double serr, double derr)
{
	size_t          len;
	char           *end;

	len = nelem * SizeOf(dtype);
	if (dtype == stype)
	{
		memcpy(dst, src, len);
		return;
	}

	ERROR_IF_V(dtype == RGBA && stype == RGBA);
	ERROR_IF_V(dtype == RGBA);
	ERROR_IF_V(stype == RGBA);

	end = (char *)dst + len;

	_SWITCH2(dtype, stype, _SWITCH1, _CONVERT_DISCRETE_ERR);
	ERROR_HANDLER("convert_discrete_error");
	ERROR_END;
}

void SM_StringsFree(SM_strings * s)
{
int4 i;

	TERMINATE_IF(s == NULL);

	if (s->str != NULL) {
		for (i = 0; i < s->num; i++) {
			deallocate(s->str[i]);
			s->str[i] = NULL;
		}
		deallocate(s->str);
		s->str = NULL;
	}
	deallocate(s->name);
	s->name = NULL;
	deallocate(s);

	ERROR_HANDLER("SM_StringsFree");
	ERROR_END;
}

char *StringCopy(const char *str)
{
char *ret = NULL;

	TERMINATE_IF(str == NULL);

	ret = strdup(str);
	ERROR_IF_M1(ret == NULL, "%s", strerror(errno));

	ERROR_HANDLER("StringCopy");
	RETURN(ret);
}

void _ErrClear(void)
{
	ErrLine = -1;
	memset(&Err, 0, sizeof Err);
	memset(ErrMsg, 0, sizeof ErrMsg);
}

static void OpenErrFile(void)
{
	if (*ErrFileName == 0)
		ErrFile = stderr;
	else {
		if (strcmp(ErrFileName, "stdout") == 0)
			ErrFile = stdout;
		else if (strcmp(ErrFileName, "stderr") == 0)
			ErrFile = stderr;
		else {
			ErrFile = fopen(ErrFileName, "a");
			if (ErrFile == NULL) {
				printf("\nUnable to open error file %s\n", ErrFileName);
				ErrFile = stderr;
			}
		}
	}
}

void fillvalue(void *dst, int4 type, int4 width, int4 xmin, int4 xmax,
			   int4 ymin, int4 ymax, double val)
{
	if (type == RGBA) {
		ERROR_IF_V(val < 0 || val > 0x00ffffff);
		type = U_INT4;
	}
	_SWITCH1(type, width, _FILL_VALUE);
	ERROR_HANDLER("fillvalue");
	ERROR_END;
}

FILE *FM_FileOpen(const char *path, const char *mode)
{
FILE *fp = NULL;

	ERROR_IF_V(path == NULL);
	ERROR_IF_V(mode == NULL);

	fp = fopen(path, mode);
	ERROR_IF_M2(fp == NULL, "fopen: %s %s", path, strerror(errno));

	ERROR_HANDLER("FM_FileOpen");
	RETURN(fp);
}

int4 _FM_FileExistence(const char *file_path, struct stat *p_buf)
{
   ERROR_IF_V(p_buf==NULL);
 
	if (access(file_path, F_OK) == 0)
		{
         stat(file_path, p_buf);
         if (S_ISREG(p_buf->st_mode))
           return 1;
         else
           return 2;
        }
	else
		return 0;
        
 ERROR_HANDLER_BEGIN("_FM_FileExistence");
 ERROR_HANDLER_END;
 RETURN(-1);	
}

int4 getintvalue(void *src, int4 type, size_t idx)
{
	if (type == RGBA) {
		u_int4 ret = ((u_int4 *) src)[idx];
		ERROR_IF_V(ret & 0xff000000U);
		return (int4) ret;
	}

	_SWITCH1(type, idx, _GET_INTVALUE);
	ERROR_HANDLER("getintvalue");
	RETURN(-1);
}

double getvalue(void *src, int4 type, size_t idx)
{
	if (type == RGBA) {
		u_int4 ret = ((u_int4 *) src)[idx];
		ERROR_IF_V(ret & 0xff000000U);
		return (double) ret;
	}

	_SWITCH1(type, idx, _GET_VALUE);
	ERROR_HANDLER("getvalue");
	RETURN(-1.);
}

void _HandleErr(const char *file_name, const char *function_name)
{
	if (ErrVerbose) {
		OpenErrFile();
		fprintf(ErrFile, "ERROR[%d]: ", getpid());
		if (Err.ErrCode)
			fprintf(ErrFile, "%d ", Err.ErrCode);
		fprintf(ErrFile, "%s:%d ", file_name, ErrLine);
		if (function_name)
			fprintf(ErrFile, "%s", function_name);
		fprintf(ErrFile, ": %s\n", ErrMsg);
		CloseErrFile();
	}
	ERROR_CLEAR;
}

void _HandleWarn(const char *file_name, int line_no)
{
	WarnCount++;
	if (WarnVerbose) {
		OpenErrFile();
		fprintf(ErrFile, "WARNING[%d]: %s:%d: %s\n",  getpid(), file_name, line_no, ErrMsg);
		CloseErrFile();
	}
}

double IP_DistanceBetweenPoints(IP_point point1, IP_point point2)
{
	return hypot(point1.x - point2.x, point1.y - point2.y);
}

void IP_ImageFree(IP_image * image){
    TERMINATE_IF(image == NULL); /* A null pointer is also allowed, this allows multiple calls on the same pointer. */

    if (image->data != NULL) 
    {
        deallocate(image->data[0]); /* To deallocate the **data member, first deallocate the content of image->*data (by data[0]) */
        deallocate(image->data);    /* then deallocate image->data */
    }
    deallocate(image->name);
    deallocate(image);

    ERROR_HANDLER("IP_ImageFree");
    ERROR_END;
}

IP_image *IP_ImageAlloc(int4 type, int4 width, int4 height){
    /* Declaration of everything before the first jump (error handling). */
    int4 j = 0, line_size;
    IP_image *image = NULL;
    u_c *line_pt = NULL;

    /* Verify if we have a valid image */
    ERROR_IF_M1(width < 0, "width < 0 (%d)", width);
    ERROR_IF_M1(height < 0, "height < 0 (%d)", height);

    /* Verify the validity of the type, SizeOf(type), while determining the linesize in bytes. */
    line_size = width * SizeOf(type); JOE;

    /* Allocate the image */
    image = (IP_image *) allocate(sizeof *image); JOE;

    /* Set all members of image. */
    image->type = type;
    image->width = width;
    image->height = height;
    image->name = NULL;
    image->data = NULL;

    /* It is valid to define an empty image, in this case we are done and jump to the end. */
    TERMINATE_IF(width == 0 || height == 0);

    /* Set the **data member of image */
    image->data = (u_c **) allocate(height * sizeof (u_c *)); JOE; /* We need as much pointers as we have lines */
    line_pt = (u_c *) allocate(height * line_size); JOE; /* We allocate height * line_size space (width x height x  type size) */

    while (j < height) 
    {
        image->data[j++] = line_pt;
        line_pt += line_size;
    } /* Let the pointer of each line point to the begnning of each line. */

    ERROR_HANDLER_BEGIN("IP_ImageAlloc");
        IP_ImageFree(image);
        image = NULL;
    ERROR_HANDLER_END;
    RETURN(image);
}

void convert(void *dst, int4 dtype, const void *src, int4 stype, size_t nelem)
{
size_t len;
char *end;

	len = nelem * SizeOf(dtype);
	if (dtype == stype) {
		memcpy(dst, src, len);
		return;
	}
    
	ERROR_IF_V(dtype == RGBA && stype == RGBA);
	ERROR_IF_V(dtype == RGBA);
	ERROR_IF_V(stype == RGBA);
    
	end = (char *) dst + len;

	_SWITCH2(dtype, stype, _SWITCH1, _CONVERT);
	ERROR_HANDLER("convert");
	ERROR_END;
}

IP_image       *IP_ImageConvertTypeDiscrete(IP_image * im, int4 dest_type, double quanta, double offset)
{
	IP_image       *res = NULL;

	ERROR_IF_V(im == NULL);

	res = IP_ImageAlloc(dest_type, im->width, im->height);
	JOE;
	convert_discrete(res->data[0], dest_type, im->data[0], im->type,
					 im->width * im->height, quanta, offset);
	JOE;

	ERROR_HANDLER("IP_ImageConvertTypeDiscrete");
	RETURN(res);
}

IP_image       *IP_ImageConvertTypeDiscreteError(IP_image * im, int4 dest_type, double quanta, double offset, double serr,
										 double derr)
{
	IP_image       *res = NULL;

	ERROR_IF_V(im == NULL);

	res = IP_ImageAlloc(dest_type, im->width, im->height);
	JOE;
	convert_discrete_error(res->data[0], dest_type, im->data[0], im->type,
					 im->width * im->height, quanta, offset, serr, derr);
	JOE;

	ERROR_HANDLER("IP_ImageConvertTypeDiscreteError");
	RETURN(res);
}

IP_image *IP_ImageCopy(IP_image * image){
    IP_image *returnImage = NULL;
    int4 type_size;

    ERROR_IF_V(image == NULL);

    returnImage = IP_ImageAlloc(image->type, image->width, image->height); JOE;
    TERMINATE_IF(image->width == 0 || image->height == 0); /* Nothing to be done in this case. Except name? */

    type_size = SizeOf(image->type); JOE;

    memcpy(returnImage->data[0], image->data[0],
           image->height * image->width * type_size);

    if (image->name != NULL) 
    {
        returnImage->name = StringCopy(image->name); JOE;
    }

    ERROR_HANDLER_BEGIN("IP_ImageCopy");
        IP_ImageFree(returnImage);
        returnImage = NULL;
    ERROR_HANDLER_END;
    RETURN(returnImage);
}

int4 IP_ImageRectangleIntersection(IP_image * image, IP_rectangle * rectangle,
                                   int4 * xmin, int4 * xmax, int4 * ymin, int4 * ymax){
    int4 rc = 0;

    if (rectangle == NULL) {
        ERROR_IF_V(image == NULL);
        *xmin = 0;
        *xmax = image->width;
        *ymin = 0;
        *ymax = image->height;
    } 
    else {
        *xmin = rectangle->ul.x;
        *xmax = rectangle->lr.x;
        *ymin = rectangle->ul.y;
        *ymax = rectangle->lr.y;
        if (image != NULL) {
            *xmin = CLAMP(*xmin, 0, image->width); /* CLAMP: clamps a value between min and max */
            *xmax = CLAMP(*xmax, 0, image->width);
            *ymin = CLAMP(*ymin, 0, image->height);
            *ymax = CLAMP(*ymax, 0, image->height);
        }
    }

    ERROR_HANDLER_BEGIN("IP_ImageRectangleIntersection");
        rc = -1;
    ERROR_HANDLER_END;
    RETURN(rc);
}

IP_image *IP_ImageExtractRectangle(IP_image * sourceImage, IP_rectangle * rectangle){
    IP_image *returnImage = NULL;
    int4     width, height, xmin, ymin, xmax, ymax, dst_line_size;
    int4     j, type, type_size;
    u_c      *src_data = NULL, *dst_data = NULL;

    ERROR_IF_V(sourceImage == NULL);

    IP_ImageRectangleIntersection(sourceImage, rectangle, &xmin, &xmax, &ymin, &ymax); JOE;

    width  = rectangle->lr.x - rectangle->ul.x;
    height = rectangle->lr.y - rectangle->ul.y;
    type   = sourceImage->type;
    type_size = SizeOf(type);

    returnImage = IP_ImageAlloc(type, width, height); JOE;
    TERMINATE_IF(width == 0 || height == 0);

    for(j=ymin;j<ymax;j++) 
    {
        src_data = sourceImage->data[j] + xmin * type_size;
        dst_data = returnImage->data[j - rectangle->ul.y] + (xmin - rectangle->ul.x) * type_size;
        dst_line_size = (xmax-xmin) * type_size;
        memcpy(dst_data, src_data, dst_line_size);
    }

    ERROR_HANDLER_BEGIN("IP_ImageExtractRectangle");
        IP_ImageFree(returnImage);
        returnImage = NULL;
    ERROR_HANDLER_END;
    RETURN(returnImage);
}

void IP_ImageFillRectangle(IP_image * im, IP_rectangle * rec, double value)
{
int4 xmin, xmax, ymin, ymax;

	ERROR_IF_V(im == NULL);

	IP_ImageRectangleIntersection(im, rec, &xmin, &xmax, &ymin, &ymax);
	JOE;
	fillvalue(im->data[0], im->type, im->width, xmin, xmax, ymin, ymax, value);
	JOE;

	ERROR_HANDLER("IP_ImageFillRectangle");
	ERROR_END;
}

void IP_ImageAdrFree(IP_image ** image){
    TERMINATE_IF(image == NULL);
    IP_ImageFree(*image);JOE;
    *image = NULL;

    ERROR_HANDLER("IP_ImageAdrFree");
    ERROR_END;
}

int4 IP_ImageGetIntValue(IP_image * im, int4 x, int4 y)
{
int4 res = -1;

	ERROR_IF_V(im == NULL);
	ERROR_IF_V(x < 0);
	ERROR_IF_V(y < 0);
	ERROR_IF_V(x >= im->width);
	ERROR_IF_V(y >= im->height);

	res = getintvalue(im->data[0], im->type, y * im->width + x);
	JOE;

	ERROR_HANDLER_BEGIN("IP_ImageGetIntValue");
	res = -1;
	ERROR_HANDLER_END;
	RETURN(res);
}

double IP_ImageGetValue(IP_image * im, int4 x, int4 y)
{
    double res = -1.;

    ERROR_IF_V(im == NULL);
    ERROR_IF_V(x < 0);
    ERROR_IF_V(y < 0);
    ERROR_IF_V(x >= im->width);
    ERROR_IF_V(y >= im->height);

    res = getvalue(im->data[0], im->type, y * im->width + x); JOE;

    ERROR_HANDLER_BEGIN("IP_ImageGetValue");
        res = -1.;
    ERROR_HANDLER_END;
    RETURN(res);
}

void putvalue(void *dst, int4 type, size_t idx, double val)
{
	if (type == RGBA) {
		ERROR_IF_V(val < 0 || val > 0x00ffffff);
		type = U_INT4;
	}
	_SWITCH1(type, idx, _PUT_VALUE);
	ERROR_HANDLER("putvalue");
	ERROR_END;
}

void ErrorPrintf(const char *format, ...)
{
va_list va;

	if (ErrVerbose) {
		OpenErrFile();
		fprintf(ErrFile, "ERROR COMMENT: ");
		va_start(va, format);
		vfprintf(ErrFile, format, va);
		va_end(va);
		CloseErrFile();
	}
}

IP_image *IP_ImageExtract(IP_image * sourceImage, IP_rectangle * rectangle){
    IP_image *destinationImage = NULL;
    int4 width, height, xmin, ymin, xmax, ymax, src_line_size, dst_line_size;
    int4 j = 0, type, type_size;
    u_c *src_data = NULL, **dst_data = NULL;

    ERROR_IF_V(sourceImage == NULL); /* One cannot extract anything from an empty image */

    IP_ImageRectangleIntersection(sourceImage, rectangle, &xmin, &xmax, &ymin, &ymax); JOE; /* Determine the intersection */

    width  = xmax - xmin;
    height = ymax - ymin;
    type = sourceImage->type;
    type_size = SizeOf(type);

    destinationImage = IP_ImageAlloc(type, width, height); JOE;
    TERMINATE_IF(width == 0 || height == 0);

    /* Make a bunch of pointers to places in the IP_images to do the while loop on */
    src_line_size = sourceImage->width * type_size; 
    src_data = sourceImage->data[ymin] + xmin * type_size;
    dst_line_size = width * type_size;
    dst_data = destinationImage->data;

    /* Copy the data */
    while (j < height) 
    {
        memcpy(dst_data[j++], src_data, dst_line_size);
        src_data += src_line_size;
    }

    ERROR_HANDLER_BEGIN("IP_ImageExtract");
        IP_ImageFree(destinationImage);
        destinationImage = NULL;
    ERROR_HANDLER_END;
    RETURN(destinationImage);
}

void *reallocate(void *ptr, size_t size)
{
	ERROR_IF_M(size > MAX_UINT(size_t), PARAMETER_ERR);

	if (size == 0) {
		deallocate(ptr);
		ptr = NULL;
		TERMINATE;
	}

	if (ptr == NULL) {
		ptr = allocate(size);
		TERMINATE;
	}

	ERROR_IF_M((ptr = realloc(ptr, size)) == NULL, ALLOCATION_ERR);

	ERROR_HANDLER("reallocate");
	RETURN(ptr);
}

void IP_ImagesFree(IP_images * images)
{
int4 i;

	TERMINATE_IF(images == NULL);

	if (images->image != NULL) {
		for (i = 0; i < images->num; i++)
			if (images->image[i] != NULL)
				IP_ImageAdrFree(&(images->image[i]));

		deallocate(images->image);
		images->image = NULL;
	}

	deallocate(images->name);
	images->name = NULL;
	deallocate(images);

	ERROR_HANDLER("IP_ImagesFree");
	ERROR_END;
}

IP_images *IP_ImagesAlloc(int4 num)
{
IP_images *images = NULL;
int4 i;

	ERROR_IF_V(num < 0);

	images = (IP_images *) allocate(sizeof (IP_images));
	JOE;

	images->num = num;
	images->name = NULL;
	images->image = (IP_image **) allocate(sizeof (IP_image *) * num);
	JOE;

	for (i = 0; i < num; i++)
		images->image[i] = NULL;

	ERROR_HANDLER("IP_ImagesAlloc");
	RETURN(images);
}

IP_images *IP_ImagesCopy(IP_images * ims)
{
IP_images *ims_out = NULL;
int4 k;

	ERROR_IF_V(ims == NULL);
	ERROR_IF_V(ims->num <= 0);

	ims_out = IP_ImagesAlloc(ims->num);
	JOE;

	for (k = 0; k < ims->num; k++) {
		/*ERROR_IF_M(ims->image[k]==NULL,"ims->image[k]==NULL"); */
		if (ims->image[k] != NULL)
			ims_out->image[k] = IP_ImageCopy(ims->image[k]);
		JOE;
	}

	ERROR_HANDLER("IP_ImagesCopy");
	RETURN(ims_out);
}

IP_images *IP_ImagesExtract(IP_images * ims, int4 offset, int4 sampling_ratio,
							int4 num)
{
int4 k, ind;
IP_images *ims_out = NULL;

	ERROR_IF_V(ims == NULL);
	ERROR_IF_V((offset + (num - 1) * sampling_ratio) > ims->num);

	ims_out = IP_ImagesAlloc(num);
	JOE;

	for (k = 0; k < ims_out->num; k++) {
		ind = offset + k * sampling_ratio;
		ims_out->image[k] = IP_ImageCopy(ims->image[ind]);
		JOE;
	}

	ERROR_HANDLER("IP_ImagesExtract");
	RETURN(ims_out);
}

void IP_ImagesAdrFree(IP_images ** images)
{
	TERMINATE_IF(images == NULL);
	IP_ImagesFree(*images);
	JOE;
	*images = NULL;
	ERROR_HANDLER("IP_ImagesAdrFree");
	ERROR_END;
}

int IP_IsDefaultRectangle(IP_rectangle rec){
    return (rec.ul.x==-1 && rec.ul.y==-1 && rec.lr.x==-1 && rec.lr.y==-1);
}

int4 IP_PointPositionInSegment(IP_point p, IP_point p1, IP_point p2)
{
int4 it;

	/* return 1 si p est cote p1, 2 si p est cote p2 ou 0 si p est entre p1 et p2 */
	if (abs(p1.x - p2.x) > abs(p1.y - p2.y)) {
		if (p1.x > p2.x) {
			if (p1.x < p.x)
				it = 1;
			else if (p2.x <= p.x)
				it = 0;
			else
				it = 2;
		} else {
			if (p1.x > p.x)
				it = 1;
			else if (p2.x >= p.x)
				it = 0;
			else
				it = 2;
		}
	} else {
		if (p1.y > p2.y) {
			if (p1.y < p.y)
				it = 1;
			else if (p2.y <= p.y)
				it = 0;
			else
				it = 2;
		} else {
			if (p1.y > p.y)
				it = 1;
			else if (p2.y >= p.y)
				it = 0;
			else
				it = 2;
		}
	}
	return it;
}

void MP_CartesianToPolar(double x, double y, double *radius, double *angle)
{
	*radius = hypot(x, y);
	*angle = atan2(y, x);
	if (*angle < 0)
		*angle += TWO_PI;
}

void IP_RectangleDisplay(IP_rectangle * rec)
{
	if (rec == NULL)
		printf("rectangle = (null)");
	else
		printf("rectangle  ul.x = %d  ul.y = %d  lr.x = %d  lr.y = %d\n",
			   rec->ul.x, rec->ul.y, rec->lr.x, rec->lr.y);
}

IP_point IP_RectangleShortestPath(IP_rectangle Rect1, IP_rectangle Rect2)
{
IP_point p = { 0, 0 };

	int4 up1 = Rect1.lr.y - 1;
	int4 bottom1 = Rect1.ul.y;
	int4 left1 = Rect1.ul.x;
	int4 right1 = Rect1.lr.x - 1;

	int4 up2 = Rect2.lr.y - 1;
	int4 bottom2 = Rect2.ul.y;
	int4 left2 = Rect2.ul.x;
	int4 right2 = Rect2.lr.x - 1;

	ERROR_IF_V(up1 < bottom1);
	ERROR_IF_V(right1 < left1);
	ERROR_IF_V(up2 < bottom2);
	ERROR_IF_V(right2 < left2);

	if (bottom1 > up2)
		p.y = up2 - bottom1;
	else if (up1 < bottom2)
		p.y = bottom2 - up1;
	else
		p.y = 0;

	if (right1 < left2)
		p.x = left2 - right1;
	else if (left1 > right2)
		p.x = right2 - left1;
	else
		p.x = 0;

	ERROR_HANDLER("IP_RectangleShortestPath");
	RETURN(p);
}

int4 IP_RectangleSurroundPoint(IP_point p1, IP_rectangle rec)
{
	if (p1.x >= rec.ul.x && p1.y >= rec.ul.y &&
		p1.x < rec.lr.x && p1.y < rec.lr.y)
		return 1;
	else
		return 0;
}

int IP_RectangleHasBiggerSide(IP_rectangle leftRec, IP_rectangle rightRec){
    return ((leftRec.lr.x-leftRec.ul.x)>(rightRec.lr.x-rightRec.ul.x) || (leftRec.lr.y-leftRec.ul.y)>(rightRec.lr.y-rightRec.ul.y));
}

int4 IP_RectangleInclude(IP_rectangle rec1, IP_rectangle rec2)
{
	if (rec1.ul.x >= rec2.ul.x && rec1.ul.y >= rec2.ul.y &&
		rec1.lr.x <= rec2.lr.x && rec1.lr.y <= rec2.lr.y)
		return 1;
	else
		return 0;
}

IP_rectangle IP_RectangleIntersection(IP_rectangle rec1, IP_rectangle rec2)
{
	IP_rectangle res;

	if (rec1.lr.x < rec2.ul.x || rec1.lr.y < rec2.ul.y ||
		rec2.lr.x < rec1.ul.x || rec2.lr.y < rec1.ul.y) {
		res.ul.x = res.lr.x = res.ul.y = res.lr.y = MAX_INT4;
		return res;	/* no intersection between rectangles */
	}

	if (rec1.ul.x > rec2.ul.x)
		res.ul.x = rec1.ul.x;
	else
		res.ul.x = rec2.ul.x;

	if (rec1.ul.y > rec2.ul.y)
		res.ul.y = rec1.ul.y;
	else
		res.ul.y = rec2.ul.y;

	if (rec1.lr.x < rec2.lr.x)
		res.lr.x = rec1.lr.x;
	else
		res.lr.x = rec2.lr.x;

	if (rec1.lr.y < rec2.lr.y)
		res.lr.y = rec1.lr.y;
	else
		res.lr.y = rec2.lr.y;

	return res;
}

int IP_RectangleOverlap(IP_rectangle rec1, IP_rectangle rec2){
    /** as the outher side of the rectangle is not included we need <= */
    return !(rec1.lr.x <= rec2.ul.x || rec1.lr.y <= rec2.ul.y || rec2.lr.x <= rec1.ul.x || rec2.lr.y <= rec1.ul.y);
}

IP_rectangles *IP_RectanglesAlloc(int4 num)
{
IP_rectangles *recs = NULL;

	ERROR_IF_V(num < 0);

	recs = (IP_rectangles *) allocate(sizeof (IP_rectangles));
	JOE;
	recs->num = num;
	recs->rectangle = NULL;

	TERMINATE_IF(num == 0);

	recs->rectangle = (IP_rectangle *) allocate(sizeof (IP_rectangle) * num);
	JOE;

	ERROR_HANDLER("IP_RectanglesAlloc");
	RETURN(recs);
}

double IP_RectangleDistanceFromPoint(IP_point point, IP_rectangle rec)
{
IP_point point1;
double d;

	if (IP_RectangleSurroundPoint(point, rec))
		return 0.;
	else if (point.x < rec.ul.x) {
		if (point.y < rec.ul.y)
			d = IP_DistanceBetweenPoints(point, rec.ul);
		else if (point.y < rec.lr.y)
			d = rec.ul.x - point.x;
		else {
			point1.x = rec.ul.x;
			point1.y = rec.lr.y;
			d = IP_DistanceBetweenPoints(point, point1);
		}
	} else {
		if (point.x < rec.lr.x) {
			if (point.y < rec.ul.y)
				d = rec.ul.y - point.y;
			else
				d = point.y - rec.lr.y;
		} else if (point.y > rec.lr.y)
			d = IP_DistanceBetweenPoints(point, rec.ul);
		else if (point.y > rec.ul.y)
			d = point.x - rec.lr.x;
		else {
			point1.x = rec.ul.y;
			point1.y = rec.lr.x;
			d = IP_DistanceBetweenPoints(point, point1);
		}
	}
	return d;
}

void IP_RectanglesFree(IP_rectangles * recs)
{
	ERROR_IF_V(recs == NULL);

	if (recs->rectangle != NULL) {
		deallocate(recs->rectangle);
		recs->rectangle = NULL;
	}
	deallocate(recs);

	ERROR_HANDLER("IP_RectanglesFree");
	ERROR_END;
}

double IP_RectangleDistance(IP_rectangle Rect1, IP_rectangle Rect2)
{
IP_point path = IP_RectangleShortestPath(Rect1, Rect2);
	return hypot(path.x, path.y);
}

void IP_RectanglesReallocate(IP_rectangles * recs, int4 num)
{
	ERROR_IF_V(recs == NULL);
	ERROR_IF_V(num < 0);

	recs->num = num;
	recs->rectangle = (IP_rectangle *) reallocate(recs->rectangle,
												  sizeof (IP_rectangle) * num);
	JOE;

	ERROR_HANDLER("IP_RectanglesReallocate");
	ERROR_END;
}

int4 IP_RectangleSurface(IP_rectangle rec)
{
	return (rec.lr.x - rec.ul.x) * (rec.lr.y - rec.ul.y);
}

int IP_RectangleSurroundCoordinate(IP_rectangle rec, int4 x, int4 y)
{
    return x >= rec.ul.x && y >= rec.ul.y && x < rec.lr.x && y < rec.lr.y;
}

IP_rectangle IP_RectangleUnion(IP_rectangle Rect1, IP_rectangle Rect2)
{
IP_rectangle rect;

	if (Rect1.ul.x < Rect2.ul.x)
		rect.ul.x = Rect1.ul.x;
	else
		rect.ul.x = Rect2.ul.x;

	if (Rect1.ul.y < Rect2.ul.y)
		rect.ul.y = Rect1.ul.y;
	else
		rect.ul.y = Rect2.ul.y;

	if (Rect1.lr.x > Rect2.lr.x)
		rect.lr.x = Rect1.lr.x;
	else
		rect.lr.x = Rect2.lr.x;

	if (Rect1.lr.y > Rect2.lr.y)
		rect.lr.y = Rect1.lr.y;
	else
		rect.lr.y = Rect2.lr.y;

	return rect;
}

void IP_RectangleTranslate(IP_rectangle * rec, IP_point pt)
{
	ERROR_IF_V(rec == NULL);

	rec->ul.x += pt.x;
	rec->ul.y += pt.y;
	rec->lr.x += pt.x;
	rec->lr.y += pt.y;

	ERROR_HANDLER("IP_RectangleTranslate");
	ERROR_END;
}

void IP_RectanglesCombine(IP_rectangles * recs, double maximal_distance)
{
IP_point p1, p2, p3, p4;
int4 j, k, l;

	for (j = 0; j < recs->num; j++)
		for (k = j + 1; k < recs->num; k++) {
			p1.x = recs->rectangle[k].ul.x;
			p2.y = recs->rectangle[k].ul.y;
			p1.y = recs->rectangle[k].lr.y;
			p2.x = recs->rectangle[k].lr.x;
			p3.x = recs->rectangle[j].ul.x;
			p4.y = recs->rectangle[j].ul.y;
			p3.y = recs->rectangle[j].lr.y;
			p4.x = recs->rectangle[j].lr.x;
			if (IP_RectangleDistanceFromPoint(recs->rectangle[k].ul,
											  recs->rectangle[j]) <
				maximal_distance
				|| IP_RectangleDistanceFromPoint(recs->rectangle[k].lr,
												 recs->rectangle[j]) <
				maximal_distance
				|| IP_RectangleDistanceFromPoint(p1,
												 recs->rectangle[j]) <
				maximal_distance
				|| IP_RectangleDistanceFromPoint(p2,
												 recs->rectangle[j]) <
				maximal_distance
				|| IP_RectangleDistanceFromPoint(recs->rectangle[j].lr,
												 recs->rectangle[k]) <
				maximal_distance
				|| IP_RectangleDistanceFromPoint(recs->rectangle[j].lr,
												 recs->rectangle[k]) <
				maximal_distance
				|| IP_RectangleDistanceFromPoint(p3,
												 recs->rectangle[k]) <
				maximal_distance
				|| IP_RectangleDistanceFromPoint(p4,
												 recs->rectangle[k]) <
				maximal_distance) {

				recs->rectangle[j] =
					IP_RectangleUnion(recs->rectangle[j], recs->rectangle[k]);
				for (l = k + 1; l < recs->num; l++)
					recs->rectangle[l - 1] = recs->rectangle[l];
				recs->num--;
				k = j;	/* Chaque fois que deux rectangles sont combines, on doit reprendre toute la liste */
			}
		}
}

double  LU_CdsTimeToUnix(u_int2 day, u_int4 millisec ) 
{
double  t;
  
  t = (day - 4383) * SEC_PER_DAY + 0.001*millisec ;

 return(t);
}

int4 FM_FileExistence(const char *file_path)
{
 struct stat buf;
 int4 rc;
 
 
 rc = _FM_FileExistence(file_path, &buf); JOE;
 
 ERROR_HANDLER_BEGIN("FM_FileExistence");
 ERROR_HANDLER_END;
 RETURN(rc);	
}

void LU_UnixTimeToDate(double U_time, int4 * year, int4 * month, int4 * day,
					   int4 * hour, int4 * minute, double *second, int4 * yday,
					   int4 * wday)
{
struct tm *tp = NULL;
double isec, fsec;
time_t U_time_t;

	ERROR_IF_V(U_time < 0);

	fsec = modf(U_time, &isec);
	U_time_t = (time_t) isec;

	tp = gmtime(&U_time_t);
	ERROR_IF_M(tp == NULL, "gmtime failed");

	if (year)
		*year = tp->tm_year + 1900;
	if (month)
		*month = tp->tm_mon + 1;
	if (day)
		*day = tp->tm_mday;
	if (hour)
		*hour = tp->tm_hour;
	if (minute)
		*minute = tp->tm_min;
	if (second)
		*second = tp->tm_sec + fsec;
	if (yday)
		*yday = tp->tm_yday;
	if (wday)
		*wday = tp->tm_wday;

	ERROR_HANDLER("LU_UnixTimeToDate");
	ERROR_END;
}

SM_strings *SM_StringsAlloc(int4 num)
{
SM_strings *s = NULL;
int4 i;

	ERROR_IF_V(num < 0);

	s = (SM_strings *) allocate(sizeof (SM_strings));
	JOE;
	s->num = num;
	s->name = NULL;
	s->str = (char **) allocate(num * sizeof (char *));
	JOE;

	for (i = 0; i < num; i++)
		s->str[i] = NULL;

	ERROR_HANDLER_BEGIN("SM_StringsAlloc");
	SM_StringsFree(s);
	s = NULL;
	ERROR_HANDLER_END;
	RETURN(s);
}

void SM_StringsReallocate(SM_strings * s, int4 num)
{
int4 i;
char **tmp;

	ERROR_IF_V(num < 0);
	ERROR_IF_V(s == NULL);

    TERMINATE_IF(s->num==num);
    
	for (i = num; i < s->num; i++) {
		deallocate(s->str[i]);
		s->str[i] = NULL;
	}

	tmp = (char **) reallocate(s->str, num * sizeof (char *));
	JOE;
	s->str = tmp;

	for (i = s->num; i < num; i++)
		s->str[i] = NULL;
	s->num = num;

	ERROR_HANDLER("SM_StringsReallocate");
	ERROR_END;
}

char *SM_StringExtract(char *str, int4 deb, int4 end)
{
char *res = NULL;
int4 len;

	ERROR_IF_V(str == NULL);

	len = end - deb;
	ERROR_IF_M1(deb < 0, "deb < 0 for %s", str);
	ERROR_IF_M1(len < 0, "end < deb for %s", str);
	ERROR_IF_M1(end > (int4) strlen(str), "end  > strlen(str) <%s>", str);

	res = (char *) allocate(len + 1);
	JOE;
	memcpy(res, str + deb, len);

	ERROR_HANDLER("SM_StringExtract");
	RETURN(res);
}

char *SM_StringExtractBasenameLevel(char *str, int4 level)
{
    char    *basenam = NULL;
    int4    deb, fin, k;

    ERROR_IF_V(str == NULL);

    fin = strlen(str);
    deb = fin;
    for(k=0;k<level;k++)
    {
        /* skip all the '/' char at the end */
        while(deb >0 && str[deb - 1] == '/') deb--;

        /* skip all the char up to a '/' */
        while (deb > 0 && str[deb - 1] != '/') deb--;
    }

    basenam = SM_StringExtract(str, deb, fin); JOE;
    ERROR_HANDLER("SM_StringExtractBasenameLevel");
    RETURN(basenam);
}

int4 _CL_StringSearch(char *str, SM_strings * comline)
{
int4 k = 0, res = 0;

	ERROR_IF_M(comline == NULL, CL_NO_INIT_MESSAGE);

	for (k = 0; k < comline->num; k++)
		if (strcmp(comline->str[k], str) == 0)
			{
             res = k;
             break;
            }

	ERROR_HANDLER_BEGIN("_CL_StringSearch");
	res = -1;
	ERROR_HANDLER_END;
	RETURN(res);
}

void MP_PolarToCartesian(double radius, double angle, double *x, double *y)
{
	*x = radius * cos(angle);
	*y = radius * sin(angle);
}

char *StringType(int4 type)
{
char *str_ptr = NULL;

	switch (type) {
	case BIT:
		str_ptr = StringCopy("BIT");
		break;
	case U_CHAR:
		str_ptr = StringCopy("U_CHAR");
		break;
	case CHAR:
		str_ptr = StringCopy("CHAR");
		break;
	case U_INT1:
		str_ptr = StringCopy("U_INT1");
		break;
	case INT1:
		str_ptr = StringCopy("INT1");
		break;
	case U_INT2:
		str_ptr = StringCopy("U_INT2");
		break;
	case INT2:
		str_ptr = StringCopy("INT2");
		break;
	case U_INT4:
		str_ptr = StringCopy("U_INT4");
		break;
	case INT4:
		str_ptr = StringCopy("INT4");
		break;
	case U_INT_8:
		str_ptr = StringCopy("U_INT_8");
		break;
	case INT_8:
		str_ptr = StringCopy("INT_8");
		break;
	case FLOAT:
		str_ptr = StringCopy("FLOAT");
		break;
	case DOUBLE:
		str_ptr = StringCopy("DOUBLE");
		break;
	case P2VOID:
		str_ptr = StringCopy("P2VOID");
		break;
	case RGBA:
		str_ptr = StringCopy("RGBA");
		break;
	case STRING:
		str_ptr = StringCopy("STRING");
		break;
	case SM_STRINGS:
		str_ptr = StringCopy("SM_STRINGS");
		break;
	case IP_IMAGE:
		str_ptr = StringCopy("IP_IMAGE");
		break;
	case IP_IMAGES:
		str_ptr = StringCopy("IP_IMAGES");
		break;
	case MP_VECTOR:
		str_ptr = StringCopy("MP_VECTOR");
		break;
	case MP_VECTORS:
		str_ptr = StringCopy("MP_VECTORS");
		break;
	case MP_MATRIX:
		str_ptr = StringCopy("MP_MATRIX");
		break;
	case MP_MATRICES:
		str_ptr = StringCopy("MP_MATRICES");
		break;
	case MP_INDEX:
		str_ptr = StringCopy("MP_INDEX");
		break;
	default:
		ERROR_M1("unknown type (%d)", type);
	}
	JOE;
	ERROR_HANDLER("StringType");
	RETURN(str_ptr);
}

IP_point IP_PointRotate(IP_point src, double alpha, IP_point ctr)
{
IP_point res;
double x, y, rho, theta;

	x = src.x - ctr.x;
	y = src.y - ctr.y;

	MP_CartesianToPolar(x, y, &rho, &theta);

	theta += alpha;
	MP_PolarToCartesian(rho, theta, &x, &y);

	res.x = ROUND(ctr.x + x);
	res.y = ROUND(ctr.y + y);

	return res;
}

void _OnErr(int line_no, int err_code)
{
	ErrCount++;
	ErrLine = line_no;
	Err.ErrCode = err_code;
	Err.ErrActive = Err.ErrStat = -1;
}

void _OnJOE(int line_no)
{
	strncpy(ErrMsg, PROPAGATION_ERR, sizeof ErrMsg - 1);
	ErrLine = line_no;
	Err.ErrCode = 0;
	Err.ErrActive = -1;
}

void _OnMsg(const char *Message, ...)
{
va_list va;

	if (!Message)
		ErrMsg[0] = 0;
	else {
		va_start(va, Message);
		vsnprintf(ErrMsg, sizeof ErrMsg, Message, va);	
		va_end(va);
	}
}

int4 IP_ImagePutValue(IP_image * im, int4 x, int4 y, double value)
{
int4 rc = 0;

	ERROR_IF_V(im == NULL);
	ERROR_IF_V(x < 0);
	ERROR_IF_V(y < 0);
	ERROR_IF_V(x >= im->width);
	ERROR_IF_V(y >= im->height);

	putvalue(im->data[0], im->type, y * im->width + x, value);
	JOE;

	ERROR_HANDLER_BEGIN("IP_ImagePutValue");
	rc = -1;
	ErrorPrintf("x %d y %d v %f w %d h %d\n",x,  y,  value, im->width, im->height);
	ERROR_HANDLER_END;
	RETURN(rc);
}

int4 IP_ImagePutValueIfPossible(IP_image * im, int4 x, int4 y, double value)
{
int4 rc = 0;

	ERROR_IF_V(im == NULL);

	TERMINATE_IF(x < 0);
	TERMINATE_IF(y < 0);
	TERMINATE_IF(x >= im->width);
	TERMINATE_IF(y >= im->height);

	IP_ImagePutValue(im, x, y, value);
	JOE;
	ERROR_HANDLER_BEGIN("IP_ImagePutValueIfPossible");
	rc = -1;
	ERROR_HANDLER_END;
	RETURN(rc);
}

void IP_ImagesAddImage(IP_images * ims, IP_image * im)
{
	ERROR_IF_V(ims == NULL);
	ERROR_IF_V(im == NULL);

	ims->image = (IP_image **) reallocate(ims->image,
							 (ims->num + 1) * sizeof (IP_image *));
	JOE;
	ims->image[ims->num] = IP_ImageCopy(im);
	JOE;
	ims->num += 1;

	ERROR_HANDLER("IP_ImagesAddImage");
	ERROR_END;
}

void SetErrorFile(const char *Name)
{
FILE *fptr = NULL;

	if (Name == NULL || *Name == 0)
		ErrFileName[0] = 0;
	else {
		if ((fptr = fopen(Name, "a")) == NULL)
			printf("\nUnable to open error file %s\n", Name);
		else {
			strncpy(ErrFileName, Name, sizeof ErrFileName - 1);
			fclose(fptr);
		}
	}
}

void SetVerbosity(int verb)
{
	if (verb)
		WarnVerbose = ErrVerbose = 1;
	else
		WarnVerbose = ErrVerbose = 0;
}

IP_image *IP_ImageConvertType(IP_image * im, int4 dest_type)
{
IP_image *res = NULL;

	ERROR_IF_V(im == NULL);

	res = IP_ImageAlloc(dest_type, im->width, im->height);
	JOE;
	convert(res->data[0], dest_type, im->data[0], im->type,
			im->width * im->height);
	JOE;

	ERROR_HANDLER("IP_ImageConvertType");
	RETURN(res);
}

int4 SM_StringIsEmpty(const char *str)
{
int4 rc = -1;

	ERROR_IF_V(str == NULL);

	rc = strspn(str, " \t\n");
	if (str[rc] == '\0')
		rc = 1;
	else
		rc = 0;

	ERROR_HANDLER("SM_StringIsEmpty");
	RETURN(rc);
}

SM_strings *SM_StringsAddString(SM_strings * strings, char *str)
{

	/* ERROR_IF_V(strings == NULL); */
	/*ERROR_IF_V(str == NULL);*/

    if (strings == NULL)
    {
        strings = SM_StringsAlloc(1);
        JOE;
    }
    else
    {
	SM_StringsReallocate(strings, strings->num + 1);
	JOE;    
    }

    strings->str[strings->num - 1] = StringCopy(str);
    JOE;   


	ERROR_HANDLER_BEGIN("SM_StringsAddString");
    ERROR_HANDLER_END;
    RETURN(strings);
}

SM_strings *SM_StringsAddStringPointer(SM_strings * strings, char *str)
{
	ERROR_IF_V(str == NULL);

	if (strings != NULL)
		SM_StringsReallocate(strings, strings->num + 1);
	else
		strings = SM_StringsAlloc(1);
	JOE;
	strings->str[strings->num - 1] = str;
	JOE;

	ERROR_HANDLER("SM_StringsAddStringPointer");
	RETURN(strings);
}

void SM_StringsAddStrings(SM_strings * s1, SM_strings * s2)
{
int4 k, n;

	ERROR_IF_V(s1 == NULL);
	ERROR_IF_V(s2 == NULL);

	n = s1->num;

	SM_StringsReallocate(s1, s1->num + s2->num);
	JOE;
	for (k = 0; k < s2->num; k++) {
		s1->str[k + n] = StringCopy(s2->str[k]);
		JOE;
	}

	ERROR_HANDLER("SM_StringsAddStrings");
	ERROR_END;
}

SM_strings *SM_StringsCopy(SM_strings * s)
{
SM_strings *s_out = NULL;
int4 k;

	ERROR_IF_V(s == NULL);

	s_out = SM_StringsAlloc(s->num);
	JOE;
	s_out->name = StringCopy(s->name);
	JOE;
	for (k = 0; k < s->num; k++) {
		s_out->str[k] = StringCopy(s->str[k]);
		JOE;
	}

	ERROR_HANDLER_BEGIN("SM_StringsCopy");
	SM_StringsFree(s_out);
	s_out = NULL;
	ERROR_HANDLER_END;
	RETURN(s_out);
}

void SM_StringsAdrFree(SM_strings ** s)
{
	TERMINATE_IF(*s == NULL);
	SM_StringsFree(*s);
	*s = NULL;
	ERROR_HANDLER("SM_StringsAdrFree");
	ERROR_END;
}

SM_strings *SM_StringsAddToStrings(SM_strings * strs, const char *list, ...)
{
int4 num = 0, i, size;
const char *first;
va_list ap;

	if (strs == NULL) {
		strs = SM_StringsAlloc(0);
		JOE;
	}

	first = list;
	va_start(ap, list);
	while (list != NULL) {
		num++;
		list = va_arg(ap, const char *);
	}
	va_end(ap);

	size = strs->num;
	SM_StringsReallocate(strs, num + strs->num);
	JOE;

	list = first;
	va_start(ap, list);
	for (i = 0; i < num; i++) {
		strs->str[i + size] = StringCopy((char *) list);
		JOE;
		list = va_arg(ap, const char *);
	}
	va_end(ap);

	ERROR_HANDLER_BEGIN("SM_StringsAddToStrings");
	SM_StringsAdrFree(&strs);
	ERROR_HANDLER_END;
	RETURN(strs);
}

void SM_StringReplaceStringNOccurences(char *str, char *str_old, char *str_new,
									   int4 n_occur)
{
int4 n = 0, n_new;
char *tmp, *tmp_prev, *tmp_end, *str_cpy = NULL, *str_r;

	ERROR_IF_V(str == NULL);
	ERROR_IF_V(str_old == NULL);
	ERROR_IF_V(str_new == NULL);

	str_cpy = StringCopy(str);
	JOE;

	tmp = tmp_prev = str_cpy;
	tmp_end = str_cpy + strlen(str_cpy);

	str_r = str;
	n_new = strlen(str_new);

	while ((n < n_occur || n_occur == 0) &&
		   (tmp = strstr(tmp, str_old)) != NULL) {
		/*printf("%s %s %s %d\n",str_r, tmp_prev, tmp, tmp-tmp_prev); */
		strncpy(str_r, tmp_prev, tmp - tmp_prev);
		str_r = str_r + (tmp - tmp_prev);

		strncpy(str_r, str_new, n_new);
		str_r = str_r + n_new;

		tmp += strlen(str_old);
		tmp_prev = tmp;

		n++;
	}
	/*printf("%s %s %d\n",str_r, tmp_prev, tmp_end-tmp_prev); */
	strncpy(str_r, tmp_prev, tmp_end - tmp_prev);
	str_r[tmp_end - tmp_prev] = '\0';

	ERROR_HANDLER("SM_StringReplaceStringNOccurences");
	deallocate(str_cpy);
	ERROR_END;
}

SM_strings *SM_StringsAllocList(const char *list, ...)
{
SM_strings *strings = NULL;
int4 num = 0, i;
const char *first;
va_list ap;

	first = list;
	va_start(ap, list);
	while (list != NULL) {
		num++;
		list = va_arg(ap, const char *);
	}
	va_end(ap);

	strings = SM_StringsAlloc(num);
	JOE;

	list = first;
	va_start(ap, list);
	for (i = 0; i < num; i++) {
		strings->str[i] = StringCopy((char *) list);
		JOE;
		list = va_arg(ap, const char *);
	}
	va_end(ap);

	ERROR_HANDLER_BEGIN("SM_StringsAllocList");
	SM_StringsFree(strings);
	strings = NULL;
	ERROR_HANDLER_END;
	RETURN(strings);
}

SM_strings *SM_StringsAddStrings2(SM_strings * s1, SM_strings * s2)
{
	if (s1 != NULL && s2 != NULL) {
		SM_StringsAddStrings(s1, s2);
		JOE;
	} else 
		if (s1 == NULL) {
			s1 = SM_StringsCopy(s2);
			JOE;
		}
	ERROR_HANDLER("SM_StringsAddStrings2");
	RETURN(s1);
}

void SM_StringsDisplay(SM_strings * s)
{
int4 k;

	printf("SM_StringsDisplay :\n");

	if (s == NULL) {
		printf("(null)\n");
		TERMINATE;
	}

	printf("  - number of strings : s->num = %d\n", s->num);

	for (k = 0; k < s->num; k++)
		if (s->str[k] != NULL)
			printf("  - s->str[%3d] = %s\n", k, s->str[k]);
		else
			printf("  - s->str[%3d] = (null) \n", k);

	ERROR_HANDLER("SM_StringsDisplay");
	ERROR_END;
}

void SM_StringsDisplayErr(SM_strings * s)
{
int4 k;

	ErrorPrintf("SM_StringsDisplay :\n");

	if (s == NULL) {
		ErrorPrintf("(null)\n");
		TERMINATE;
	}

	ErrorPrintf("  - number of strings : s->num = %d\n", s->num);

	for (k = 0; k < s->num; k++)
		if (s->str[k] != NULL)
			ErrorPrintf("  - s->str[%3d] = %s\n", k, s->str[k]);
		else
			ErrorPrintf("  - s->str[%3d] = (null) \n", k);

	ERROR_HANDLER("SM_StringsDisplayErr");
	ERROR_END;
}

char *LU_GetLine(FILE * stream)
{
char *buf = NULL, *ptr, *tmp;
size_t len, chunk = 256, offset = 0;

	ERROR_IF_V(stream == NULL);
	TERMINATE_IF(feof(stream));

	buf = (char *) allocate(chunk);
	JOE;

	for (;;) {
		ptr = buf + offset;

		tmp = fgets(ptr, chunk, stream);
		if (feof(stream)) {
			if (tmp)
				offset += strlen(tmp) + 1;
			break;
		}
		ERROR_IF_M1(tmp == NULL, "%s", strerror(errno));

		len = strlen(tmp);
		offset += len;

		if (tmp[len - 1] == '\n') {
			tmp[len - 1] = '\0';
			break;
		}

		chunk *= 2;
		tmp = (char *) reallocate(buf, offset + chunk);
		JOE;
		buf = tmp;
	}

	/* no character between last \n and EOF */
	if (!offset) {
		deallocate(buf);
		return NULL;
	}

	tmp = (char *) reallocate(buf, offset);
	JOE;
	tmp[offset - 1] = '\0';
	buf = tmp;

	ERROR_HANDLER_BEGIN("LU_GetLine");
	deallocate(buf);
	buf = NULL;
	ERROR_HANDLER_END;
	RETURN(buf);
}

SM_strings *LU_ReadStream(FILE * stream)
{
SM_strings *strs = NULL;
int4 num_lines = 512, k = 0;
char *line;

	ERROR_IF_V(stream == NULL);
	strs = SM_StringsAlloc(num_lines);
	JOE;

	while ((line = LU_GetLine(stream)) != NULL) {
		strs->str[k] = line;
		k++;

		if (k == num_lines) {
			num_lines *= 2;
			SM_StringsReallocate(strs, num_lines);
			JOE;
		}
	}
	JOE;

	SM_StringsReallocate(strs, k);
	JOE;

	ERROR_HANDLER_BEGIN("LU_ReadStream");
	SM_StringsFree(strs);
	strs = NULL;
	ERROR_HANDLER_END;
	RETURN(strs);
}

static int descend(const char *name, const struct stat *ptr, int flag,
				   struct FTW *ftw_s)
{
static SM_strings *strs = NULL;
static int4 num = 0;
static int4 depth = 0;
static int4 nodirs = 0;

	/* reset static variables */
	if (ftw_s == NULL) {
		if (name == NULL)
			return num;
		strs = (SM_strings *) name;
		num = 0;
		depth = flag & ~DIRDIR_FLAG;
		nodirs = flag & DIRDIR_FLAG;
		return 0;
	}

	if ((nodirs || flag != FTW_D) && flag != FTW_F)
		return 0;
	if (ftw_s->level == 0 || (depth != 0 && ftw_s->level > depth))
		return 0;

	strs->str[num++] = StringCopy(name);
	JOE;
	if (num == strs->num) {
		SM_StringsReallocate(strs, 2 * num);
		JOE;
	}
	return 0;

	ERROR_HANDLER("descend");
	ptr = ptr;
	RETURN(1);
}

void SM_StringsReorganise(SM_strings * s)
{
int4 k, n = 0;

	ERROR_IF_V(s == NULL);

	for (k = 0; k < s->num; k++)
		if (s->str[k])
			s->str[n++] = s->str[k];

	for (k = n; k < s->num; k++)
		s->str[k] = NULL;

	SM_StringsReallocate(s, n);
	JOE;

	ERROR_HANDLER("SM_StringsReorganise");
	ERROR_END;
}

void SM_StringsRemoveEmptyStrings(SM_strings * s)
{
int4 k;

	ERROR_IF_V(s == NULL);

	for (k = 0; k < s->num; k++)
		if (s->str[k] && SM_StringIsEmpty(s->str[k])) {
			deallocate(s->str[k]);
			s->str[k] = NULL;
		}
	SM_StringsReorganise(s);
	JOE;

	ERROR_HANDLER("SM_StringsRemoveEmptyStrings");
	ERROR_END;
}

void SM_StringsWrite(const char *filename, const SM_strings * s)
{
FILE *fp = NULL;
int4 k;

	ERROR_IF_V(s == NULL);
	ERROR_IF_V(s->num < 0);

	fp = FM_FileOpen(filename, "w");
	JOE;
	for (k = 0; k < s->num; k++)
		if (s->str[k] == NULL)
			fprintf(fp, "\n");
		else
			fprintf(fp, "%s\n", s->str[k]);

	ERROR_HANDLER("SM_StringsWrite");
	if (fp != NULL)
		fclose(fp);
	ERROR_END;
}

char *StringConcat(const char *str1, const char *str2)
{
char *string1 = NULL;
size_t n1, n2;

	TERMINATE_IF(str1 == NULL && str2 == NULL);

	n1 = (str1 == NULL) ? 0 : strlen(str1);
	n2 = (str2 == NULL) ? 0 : strlen(str2);

	string1 = (char *) allocate(n1 + n2 + 1);
	JOE;

	if (n1)
		memcpy(string1, str1, n1);
	if (n2)
		memcpy(string1 + n1, str2, n2);

	ERROR_HANDLER("StringConcat");
	RETURN(string1);
}

void SM_StringReplaceString(char *str, char *str_old, char *str_new)
{
	ERROR_IF_V(str == NULL);
	ERROR_IF_V(str_old == NULL);
	ERROR_IF_V(str_new == NULL);

	SM_StringReplaceStringNOccurences(str, str_old, str_new, 0);
	JOE;

	ERROR_HANDLER("SM_StringReplaceString");
	ERROR_END;
}

void CL_Free(void)
{
	SM_StringsAdrFree(&global_comline);
	SM_StringsAdrFree(&global_comline_complete);
}

int4 FM_FileRemove(char *name)
{
int4 rc = 0;

	ERROR_IF_V(name == NULL);
/*	ERROR_IF_M2(remove(name) == -1, "remove: %s %s", name, strerror(errno));*/

    
    rc = unlink(name);
    
    if (rc == -1 && FM_FileExistence(name))
     {
      ERROR_IF_M2((rc=unlink(name)) == -1, "unlink: %s %s", name, strerror(errno));
     }


	ERROR_HANDLER_BEGIN("FM_FileRemove");
	ERROR_HANDLER_END;
	RETURN(rc);
}

int4 SM_StringHasSuffix(char *str, char *suf)
{
int4 k, n1, n2;

	ERROR_IF_V(str == NULL);
	ERROR_IF_V(suf == NULL);

	n1 = strlen(str);
	n2 = strlen(suf);

	if (n1 < n2)
		return 0;

	for (k = 0; k < n2; k++)
		if (str[n1 - n2 + k] != suf[k])
			return 0;

	ERROR_HANDLER("SM_StringHasSuffix");
	RETURN(1);
}

char *SM_StringExtractBasename(char *str)
{
char *basenam = NULL,  *start, *str2 = NULL;

	ERROR_IF_V(str == NULL);

    if (str[0]!='\0')
     {
      /*printf("-str- -%s-\n",str);*/
	  start = strrchr(str, '/');
	  if (start && start != str && start[1] == '\0') {
		  str2 = StringCopy(str);
		  JOE;
		  str2[start-str] = '\0';
		  basenam = SM_StringExtractBasename(str2);
		  JOE;
	  } else {
		  if (!start)
			basenam = StringCopy(str);
		  else
			basenam = StringCopy(start + 1);
		  JOE;
	  }
     }
    else
     {basenam = StringCopy(str);JOE}

	ERROR_HANDLER("SM_StringExtractBasename");
	ADRFREE(str2);
	RETURN(basenam);
}

MP_index *MP_IndexAlloc(int4 dim)
{
MP_index *indx = NULL;
int4 i;

	ERROR_IF_V(dim < 0);

	indx = (MP_index *) allocate(sizeof (MP_index));
	JOE;
	indx->dim = dim;
	indx->ind = NULL;

	TERMINATE_IF(dim == 0);

	indx->ind = (int4 *) allocate(dim * sizeof (int4));
	JOE;

	for (i = 0; i < dim; i++)
		indx->ind[i] = 0;

	indx->name = NULL;

	ERROR_HANDLER_BEGIN("MP_IndexAlloc");
	indx = NULL;
	ERROR_HANDLER_END;
	RETURN(indx);
}

int4 FM_FileClose(FILE * fp)
{
int4 rc = 0;

	TERMINATE_IF(fp == NULL);
	ERROR_IF_M1(fclose(fp) == -1, "fclose: %s", strerror(errno));

	rc = 0;
	ERROR_HANDLER_BEGIN("FM_FileClose");
	rc = -1;
	ERROR_HANDLER_END;
	RETURN(rc);
}

off_t FM_FileSize(const char *name)
{
struct stat buf;
off_t size = -1;

	ERROR_IF_M2(stat(name, &buf) == -1, "stat: %s %s", name, strerror(errno));
	size = buf.st_size;

	ERROR_HANDLER_BEGIN("FM_FileSize");
	size = -1;
	ERROR_HANDLER_END;
	RETURN(size);
}

void LU_DisplayTime(double U_time)
{
int4 Y, M, D, H, Min;
double Sec;

	LU_UnixTimeToDate(U_time, &Y, &M, &D, &H, &Min, &Sec, NULL, NULL);
	JOE;
	printf("Time: %d %d %d : %d %d %f\n", Y, M, D, H, Min, Sec);

	ERROR_HANDLER("LU_DisplayTime");
	ERROR_END;
}

SM_strings *SM_StringsRead(const char *filename)
{
SM_strings *s = NULL;
FILE *fp = NULL;

	fp = FM_FileOpen(filename, "r");
	JOE;
	s = LU_ReadStream(fp);
	JOE;
	ERROR_HANDLER_BEGIN("SM_StringsRead");
	SM_StringsFree(s);
	s = NULL;
	ERROR_HANDLER_END;
	if (fp != NULL)
		fclose(fp);
	RETURN(s);
}

static SM_strings *_FM_ScanDirectory(const char *directory, int4 mode)
{
SM_strings *list = NULL;
DIR *the_dir = NULL;
int4 num = 0, two = 2, chunk = 128;
struct dirent *entry;
struct stat st;
char *file_name = NULL, *slash_dir = NULL;

	ERROR_IF_V(directory == NULL);
	if (directory[strlen(directory) - 1] == '/')
		slash_dir = StringCopy(directory);
	else
		slash_dir = StringConcat(directory, "/");
	JOE;
	ERROR_IF_M2((the_dir = opendir(directory)) == NULL, "opendir: %s %s",
				directory, strerror(errno));

	list = SM_StringsAlloc(chunk);
	JOE;
	while ((entry = readdir(the_dir))) {
		/* avoid '.' & '..' per nic request */
		if (two && entry->d_name[0] == '.' && (entry->d_name[1] == 0 ||
			(entry->d_name[1] == '.' && entry->d_name[2] == 0))) {
			--two;
			continue;
		}

		if ((mode & FTW_PHYS) || (mode & DIRDIR_FLAG)) {
			file_name = StringConcat(slash_dir, entry->d_name);
			JOE;
			if ((mode & FTW_PHYS) && (lstat(file_name, &st) || S_ISLNK(st.st_mode))) {
				ADRFREE(file_name);
				continue;
			}
			if ((mode & DIRDIR_FLAG) && (stat(file_name, &st) || S_ISDIR(st.st_mode))) {
				ADRFREE(file_name);
				continue;
			}
			ADRFREE(file_name);
		}

		list->str[num] = StringCopy(entry->d_name);
		JOE;
		num++;
		if (num == chunk) {
			chunk *= 2;
			SM_StringsReallocate(list, chunk);
			JOE;
		}
	}
	/* reallocate the list to the actual size */
	SM_StringsReallocate(list, num);
	JOE;

	ERROR_HANDLER_BEGIN("_FM_ScanDirectory");
	SM_StringsFree(list);
	list = NULL;
	ERROR_HANDLER_END;
	ADRFREE(slash_dir);
	if (the_dir)
		closedir(the_dir);
	RETURN(list);
}

void LU_StringsRegexFilter(SM_strings * list, const char *filter, int4 flags)
{
char *err_buf = NULL, reg_func[8] = "regexec";
size_t err_buf_size;
int errcode = 0, cflags = REG_EXTENDED | REG_NOSUB;
int4 k, preg_flag = 0;
regex_t preg;

	ERROR_IF_V(list == NULL);
	ERROR_IF_V(filter == NULL);

	if (flags & REGEX_ICASE)
		cflags |= REG_ICASE;
	if (flags & REGEX_NLINE)
		cflags |= REG_NEWLINE;

	memset(&preg, 0, sizeof preg);
	errcode = regcomp(&preg, filter, cflags);
	if (errcode == 0)
		preg_flag = 1;
	else {
		strcpy(reg_func, "regcomp");
		goto regex_error;
	}

	for (k = 0; k < list->num; k++)
		if (list->str[k]) {
			errcode = regexec(&preg, list->str[k], 0, NULL, 0);
			if (errcode == REG_NOMATCH) {
				deallocate(list->str[k]);
				list->str[k] = NULL;
			} else if (errcode)
				goto regex_error;
		}
	SM_StringsReorganise(list);
	JOE;
	TERMINATE;

  regex_error:
	err_buf_size = regerror(errcode, &preg, NULL, 0);
	ERROR_IF_M1(err_buf_size == 0, "%s: no reason", reg_func);
	err_buf = (char *) allocate(err_buf_size);
	JOE;
	regerror(errcode, &preg, err_buf, err_buf_size);
	ERROR_M2("%s: %s", reg_func, err_buf);

	ERROR_HANDLER_BEGIN("LU_StringsRegexFilter");
	deallocate(err_buf);
	ERROR_HANDLER_END;
	ERROR_END;
	if (preg_flag)
		regfree(&preg);
}

void SM_StringsSort(SM_strings * s)
{
char **list, *source;
int4 F, f, i, j, n;

	ERROR_IF_V(s == NULL);
	SM_StringsReorganise(s);
	JOE;

	n = s->num;
	TERMINATE_IF(n < 2);

	list = s->str;
	F = 1;

	while (F < (n / 9))
		F = 3 * F + 1;

	do {
		for (f = 0; f < F; f++)
			for (i = f + F; i < n; i += F) {
				source = list[i];
				j = i - F;
				while (j >= 0 && strcmp(list[j], source) > 0) {
					list[j + F] = list[j];
					j -= F;
				}
				list[j + F] = source;
			}
		F /= 3;
	} while (F != 0);

	ERROR_HANDLER("SM_StringsSort");
	ERROR_END;
}

void MP_IndexFree(MP_index * indx)
{
	TERMINATE_IF(indx == NULL);
	if (indx->ind != NULL) {
		deallocate(indx->ind);
		indx->ind = NULL;
	}
	if (indx->name != NULL) {
		deallocate(indx->name);
		indx->ind = NULL;
	}
	deallocate(indx);

	ERROR_HANDLER("MP_IndexFree");
	ERROR_END;
}

char *LU_StringExtractRegex(char* str, const char *filter, int4 flags)
{
char *err_buf = NULL, reg_func[8] = "regexec";
size_t err_buf_size;
int errcode = 0, cflags = REG_EXTENDED;
int4 preg_flag = 0;
regex_t preg;
regmatch_t pmatch[1];
char *str_regex=NULL;

	ERROR_IF_V(str == NULL);
	ERROR_IF_V(filter == NULL);

	if (flags & REGEX_ICASE)
		cflags |= REG_ICASE;
	if (flags & REGEX_NLINE)
		cflags |= REG_NEWLINE;

	memset(&preg, 0, sizeof preg);
	errcode = regcomp(&preg, filter, cflags);
	if (errcode == 0)
		preg_flag = 1;
	else {
		strcpy(reg_func, "regcomp");
		goto regex_error;
	}

	errcode = regexec(&preg, str, (size_t)1, pmatch, 0);
	if (errcode == 0) {
		str_regex = SM_StringExtract(str, pmatch[0].rm_so, pmatch[0].rm_eo); JOE;
	} else if (errcode != REG_NOMATCH && errcode)
		goto regex_error;

	JOE;
	TERMINATE;

  regex_error:
	err_buf_size = regerror(errcode, &preg, NULL, 0);
	ERROR_IF_M1(err_buf_size == 0, "%s: no reason", reg_func);
	err_buf = (char *) allocate(err_buf_size);
	JOE;
	regerror(errcode, &preg, err_buf, err_buf_size);
	ERROR_M2("%s: %s", reg_func, err_buf);

	ERROR_HANDLER_BEGIN("LU_StringExtractRegex");
	deallocate(err_buf);
	ERROR_HANDLER_END;
	ERROR_END;
	if (preg_flag)
		regfree(&preg);

    return str_regex;
}

int4 CL_StringSearch(char *str)
{
int4 res = 0;

	res = _CL_StringSearch(str, global_comline);
	JOE;
	ERROR_HANDLER_BEGIN("CL_StringSearch");
	res = -1;
	ERROR_HANDLER_END;
	RETURN(res);
}

void byte_swap_16(void * data, size_t num)
{
u_int2 *buf = (u_int2 *) data;

	TERMINATE_IF(num > MAX_UINT(size_t));
	ERROR_IF_V(data == NULL);

	while (num--) {
		*buf = ((*buf & 0x00ffU) << 8) |
			   ((*buf & 0xff00U) >> 8);
		buf++;
	}
	ERROR_HANDLER("byte_swap_16");
	ERROR_END;
}

char *CL_StringProcessing(char *str)
{
char *res = NULL;
int4 start, stop, len;

	ERROR_IF_V(str == NULL);

	len = strlen(str);
	start = 0;
	stop = len;

	/* remove the surrounding "..." and '...' */
	if (len >= 2 && str[0] == '"' && str[len - 1] == '"') {
		start = 1;
		stop = len - 1;
	}

	if (len >= 2 && str[0] == '\'' && str[len - 1] == '\'') {
		start = 1;
		stop = len - 1;
	}

	res = SM_StringExtract(str, start, stop);
	JOE;

	/* replacement of the /n and /t 2-characters strings by /n and /t simple character */
	SM_StringReplaceString(res, "\\n", "\n");
	JOE;
	SM_StringReplaceString(res, "\\t", "\t");
	JOE;

	ERROR_HANDLER_BEGIN("CL_StringProcessing");
	deallocate(res);
	res = NULL;
	ERROR_HANDLER_END;
	RETURN(res);
}

char *StringsConcat(int4 nb, ...)
{
char *string1 = NULL, **s = NULL;
int4 n = 0, i, err = -1;
MP_index *n_ind = NULL;
va_list ap;

	ERROR_IF_V(nb < 0);
	TERMINATE_IF(nb == 0);

	s = (char **) allocate(sizeof (char *) * nb);
	JOE;

	n_ind = MP_IndexAlloc(nb);
	JOE;

	va_start(ap, nb);
	for (i = 0; i < nb; i++) {
		s[i] = va_arg(ap, char *);

		if (s[i] == NULL)
			err = i;
		n_ind->ind[i] = ((s[i] == NULL) ? 0 : strlen(s[i]));
		n += n_ind->ind[i];
	}
	va_end(ap);

	ERROR_IF_M1(err != -1, "string %d is NULL", err);

	string1 = (char *) allocate(n + 1);
	JOE;
	*string1 = 0;

	i = 0;
	while (n_ind->ind[i] == 0)
		i++;
	if (i < nb) {
		strcpy(string1, s[i]);
		i++;
	}
	while (i < nb) {
		if (n_ind->ind[i] > 0)
			strcat(string1, s[i]);
		i++;
	}

	ERROR_HANDLER("StringsConcat");
	deallocate(s);
	MP_IndexFree(n_ind);
	RETURN(string1);
}

SM_strings *LU_ScanDirectory(const char *directory, const char *regex,
							 int4 depth, int4 mode)
{
SM_strings *list = NULL;
int4 i, ft_mode = 0, dir_mode = 0, complete = 0;
size_t len;
char *file_name;

	if (mode & DIR_PHYS)
		ft_mode |= FTW_PHYS;
	if (mode & DIR_MOUNT)
		ft_mode |= FTW_MOUNT;
	if (mode & DIR_FILES)
		dir_mode = DIRDIR_FLAG;

	if (depth == -1 || depth > 0) {
		list = SM_StringsAlloc(256);
		JOE;
		descend((const char *) list, NULL, (depth + 1) | dir_mode, NULL);
		ERROR_IF_M2(nftw(directory, descend, 8, ft_mode) != 0, "nftw: %s %s",
					directory, strerror(errno));
		SM_StringsReallocate(list, descend(NULL, NULL, 0, NULL));
		JOE;
		complete = 1;
	} else {
		list = _FM_ScanDirectory(directory, ft_mode | dir_mode);
		JOE;
	}

	if (regex) {
		LU_StringsRegexFilter(list, regex, 0);
		JOE;
	}

	if (mode & DIR_SORTED) {
		SM_StringsSort(list);
		JOE;
	}

	if (!complete && (mode & DIR_COMPLETE)) {
		len = strlen(directory);
		for (i = 0; i < list->num; i++) {
			if (directory[len - 1] == '/')
				file_name = StringConcat(directory, list->str[i]);
			else
				file_name = StringsConcat(3, directory, "/", list->str[i]);
			JOE;
			deallocate(list->str[i]);
			list->str[i] = file_name;
		}
	}

	ERROR_HANDLER_BEGIN("LU_ScanDirectory");
	SM_StringsFree(list);
	list = NULL;
	ERROR_HANDLER_END;
	RETURN(list);
}

int4 FM_FileDataSyncAndClose(FILE * fp)
{
int4 rc = 0;
int fp_no;

	TERMINATE_IF(fp == NULL);

	fflush(fp);
	ERROR_IF_M1((fp_no = fileno(fp)) == -1, "fileno: %s", strerror(errno));
	ERROR_IF_M1(fdatasync(fp_no) == -1, "fdatasync: %s", strerror(errno));
	rc = FM_FileClose(fp);
	JOE;

	ERROR_HANDLER_BEGIN("FM_FileDataSyncAndClose");
	rc = -1;
	ERROR_HANDLER_END;
	RETURN(rc);
}

int4 FM_FileBunzip2(char *comp_name, char *uncomp_name)
{
 int4   rc=-1;
 int    bzerror=BZ_OK, small=0, nUnused=0, verbosity=0, nBuf=0;
 BZFILE *bz_bp=NULL;
 FILE   *bz_fp=NULL, *fp=NULL;
 char    buf[BZ2_BUFFER_SIZE];


 ERROR_IF_V(comp_name == NULL);
 ERROR_IF_V(uncomp_name == NULL);
 ERROR_IF_M1(strcmp(comp_name,uncomp_name) == 0,"Same name: %s",comp_name);

 bz_fp = FM_FileOpen(comp_name,"rb"); JOE;

 fp    = FM_FileOpen(uncomp_name,"wb"); JOE;

 bz_bp = BZ2_bzReadOpen(&bzerror,bz_fp, verbosity, small, NULL,nUnused);
 ERROR_IF_M1(bzerror!=BZ_OK,"BZ2_bzReadOpen failed with code %d",bzerror);

 bzerror = BZ_OK;

 while( bzerror == BZ_OK )
  {
    nBuf = BZ2_bzRead(&bzerror, bz_bp, buf, BZ2_BUFFER_SIZE);
    ERROR_IF_M1(bzerror!=BZ_OK && bzerror != BZ_STREAM_END,"BZ2_bzRead failed with code %d",bzerror);
    
    if (bzerror == BZ_OK || bzerror == BZ_STREAM_END)
     {
        if ((int)fwrite(buf, 1, (unsigned)nBuf, fp) != nBuf) {
            ERROR_M1("%s",strerror(errno));

       }
    
     }

  }

 BZ2_bzReadClose(&bzerror,bz_bp);

 rc = 0;
 ERROR_HANDLER_BEGIN("FM_FileBunzip2");
 rc = -1;
 if (bz_bp!=NULL) BZ2_bzReadClose(&bzerror,bz_bp);
 ERROR_HANDLER_END;

 FM_FileDataSyncAndClose(fp);
 FM_FileClose(bz_fp);
 


 
 RETURN(rc);
}

int4 FM_FileUncompress(char *gz_name, char *guz_name)
{
int4 n, rc = -1;
size_t ret, gz_buffer_size = 0, gz_file_size, gz_buffer_size_step = 0;
gzFile gz_fp = NULL;
FILE *guz_fp = NULL;
unsigned char *gz_buffer = NULL;

	ERROR_IF_V(gz_name == NULL);
	ERROR_IF_V(guz_name == NULL);

	gz_fp = gzopen(gz_name, "rb");
	ERROR_IF_M1(gz_fp == NULL, "Failed to open %s", gz_name);

#ifdef UNIX
	gz_file_size = FM_FileSize(gz_name);
	JOE;
#else
	ERROR_M("FM_FileSize not available (need lib_unix)");
#endif

	n = 1;
	gz_buffer_size_step = 2 * gz_file_size;

	do {
		ERROR_IF_M(n > 10, "Probably something wrong!!!");
		gz_buffer_size = n * gz_buffer_size_step;
        gz_buffer_size_step*=1.3;
		ADRFREE(gz_buffer);
		gz_buffer = (unsigned char *) allocate(gz_buffer_size);
		JOE;
		gzrewind(gz_fp);
		rc = gzread(gz_fp, gz_buffer, gz_buffer_size);
		/*printf("rc %d \n", rc); */
		ERROR_IF_M1(rc <= 0, "Failed reading (%s)", zError(rc));
		n++;
	} while (!gzeof(gz_fp));

	gz_buffer_size = rc;

	if (gz_fp != NULL) {
		gzclose(gz_fp);
		gz_fp = NULL;
	}

	guz_fp = FM_FileOpen(guz_name, "wb");
	JOE;
	ret = fwrite(gz_buffer, 1, gz_buffer_size, guz_fp);
	ERROR_IF_M(ret != gz_buffer_size, WRITE_ERR);

	rc = 0;
	ERROR_HANDLER_BEGIN("FM_FileUncompress");
	rc = -1;
	ERROR_HANDLER_END;
	if (guz_fp != NULL)
		fclose(guz_fp);
	if (gz_fp != NULL)
		gzclose(gz_fp);
	deallocate(gz_buffer);
	RETURN(rc);
}

char *LU_DataPreProcess(char *in, int4 *flag)
{
int4 ret, tmp_dir_flag = 0;
char *out = NULL, *basename = NULL, *tmp_dir = NULL, *cmd = NULL;

	ERROR_IF_V(in == NULL);
	ERROR_IF_M1(!FM_FileExistence(in), "File not found %s", in);

	tmp_dir = getenv("BATS_TMP");
	if (tmp_dir == NULL) {
		tmp_dir = StringCopy("/tmp");
		JOE;
		tmp_dir_flag = 1;
	}

	*flag = 0;
	out = StringCopy(in);
	JOE;
	in = NULL;

	while (in != out) {
		deallocate(in);
		in = out;

		/* test file existence */
		ERROR_IF_M1(!FM_FileExistence(in), "File not found %s", in);

		/* BZIP2 file */
		if (SM_StringHasSuffix(in, ".bz2")) {
			basename = SM_StringExtractBasename(in);
			JOE;
			basename[strlen(basename) - 4] = '\0';
			out = StringsConcat(3, tmp_dir, "/", basename);
			JOE;
            
/*
			cmd = StringsConcat(5, "bunzip2 -c ", in, " | tee ", out, " >/dev/null ; sync");
			JOE;
			ret = system(cmd);
*/

            ret = FM_FileBunzip2(in, out); JOE;            
            
/*			if (ret && FM_FileExistence("/usr/local/bin/bunzip2")==1 ) {
				deallocate(cmd);
				cmd = StringsConcat(4, "/usr/local/bin/bunzip2 -c ", in, " > ",
								  out);
				JOE;
				ret = system(cmd);
			}
			ERROR_IF_M1(ret, "when executing %s", cmd);
*/			deallocate(cmd);
			cmd = NULL;
			if (*flag == 1)
				FM_FileRemove(in);
			*flag = 1;
		}

		/* GZIP file */
		if (SM_StringHasSuffix(in, ".gz")) {
			basename = SM_StringExtractBasename(in);
			JOE;
			basename[strlen(basename) - 3] = '\0';
			out = StringsConcat(3, tmp_dir, "/", basename);
			JOE;
            
/*			cmd = StringsConcat(5, "gunzip -c ", in, " | tee ", out, " >/dev/null");
			JOE;
			ret = system(cmd);
*/

            ret = FM_FileUncompress(in, out); JOE;
            
            
/*			if (ret && FM_FileExistence("/usr/local/bin/gunzip")==1 ) {
				deallocate(cmd);
				cmd = StringsConcat(4, "/usr/local/bin/gunzip -c ", in, " > ",
								  out);
				JOE;
				ret = system(cmd);
			}
*/			ERROR_IF_M1(ret, "when executing %s", cmd);
			deallocate(cmd);
			cmd = NULL;
			if (*flag == 1)
				FM_FileRemove(in);
			*flag = 1;
		}

		/* .Z compressed file */
		if (SM_StringHasSuffix(in, ".Z")) {
			basename = SM_StringExtractBasename(in);
			JOE;
			basename[strlen(basename) - 2] = '\0';
			out = StringsConcat(3, tmp_dir, "/", basename);
			JOE;
			cmd = StringsConcat(5, "uncompress -c ", in, " | tee ", out, " >/dev/null");
			JOE;
			ret = system(cmd);
/*			if (ret && FM_FileExistence("/usr/local/bin/uncompress")==1 ) {
				deallocate(cmd);
				cmd = StringsConcat(4, "/usr/local/bin/uncompress -c ", in, " > ",
								  out);
				JOE;
				ret = system(cmd);
			}
*/			ERROR_IF_M1(ret, "when executing %s", cmd);
			deallocate(cmd);
			cmd = NULL;
			if (*flag == 1)
				FM_FileRemove(in);
			*flag = 1;
		}
	}

	ERROR_HANDLER_BEGIN("LU_DataPreProcess");
	deallocate(out);
	out = NULL;
	*flag = 0;
	ERROR_HANDLER_END;

	deallocate(cmd);
	deallocate(basename);
	if (tmp_dir_flag)
		deallocate(tmp_dir);

	RETURN(out);
}

int4 CL_Opt(char let)
{
int4 k;
char com[3];

	sprintf(com, "-%c", let);
	k = CL_StringSearch(com);
	JOE;
	ERROR_HANDLER_BEGIN("CL_Opt");
	k = -1;
	ERROR_HANDLER_END;
	RETURN(k);
}

void byte_swap_32(void * data, size_t num)
{
u_int4 *buf = (u_int4 *) data;

	TERMINATE_IF(num > MAX_UINT(size_t));
	ERROR_IF_V(data == NULL);

	while (num--) {
		*buf = ((*buf & 0x000000ffU) << 24) |
			   ((*buf & 0x0000ff00U) << 8)  |
			   ((*buf & 0x00ff0000U) >> 8)  |
			   ((*buf & 0xff000000U) >> 24);
		buf++;
	}
	ERROR_HANDLER("byte_swap_32");
	ERROR_END;
}

void byte_swap_64(void * data, size_t num)
{
u_int_8 *buf = (u_int_8 *) data;

	TERMINATE_IF(num > MAX_UINT(size_t));
	ERROR_IF_V(data == NULL);

	while (num--) {
		*buf = ((*buf & 0x00000000000000ffULL) << 56) |
			   ((*buf & 0x000000000000ff00ULL) << 40) |
			   ((*buf & 0x0000000000ff0000ULL) << 24) |
			   ((*buf & 0x00000000ff000000ULL) << 8)  |
			   ((*buf & 0x000000ff00000000ULL) >> 8)  |
			   ((*buf & 0x0000ff0000000000ULL) >> 24) |
			   ((*buf & 0x00ff000000000000ULL) >> 40) |
			   ((*buf & 0xff00000000000000ULL) >> 56);
		buf++;
	}
	ERROR_HANDLER("byte_swap_64");
	ERROR_END;
}

void byte_swap(void *data, size_t num, int4 data_type)
{
	/* If the library global variable  'bats_display_byte_swap' is set
	   to 1, each call of this routine will display a message */
	if (bats_display_byte_swap == 1)
	{
		char *str;
		str = StringType(data_type);
		JOE;
		/* standard 'z' length modifier doesn't work on tru64unix */
		printf("byte_swapping %lu %s data\n", (unsigned long) num, str);
		deallocate(str);
	}

	ERROR_IF_V(data == NULL);

	switch (data_type) {
	case BIT:
	case CHAR:
	case U_CHAR:
		break;
	case INT2:
	case U_INT2:
		byte_swap_16(data, num);
		break;
	case FLOAT:
	case INT4:
	case U_INT4:
	case RGBA:
		byte_swap_32(data, num);
		break;
	case INT_8:
	case U_INT_8:
	case DOUBLE:
		byte_swap_64(data, num);
		break;
	default:
		ERROR_M(TYPE_ERR);
	}
	ERROR_HANDLER("byte_swap");
	ERROR_END;
}

void MP_DataByteSwap(void *val, int4 type)
{
	ERROR_IF_V(val == NULL);

	byte_swap(val, 1, type);
	JOE;

	ERROR_HANDLER("MP_DataByteSwap");
	ERROR_END;
}

void CL_Init(int4 argc, char **argv)
{
int4 k;
char *tmp = NULL;

	ERROR_IF_M_C(argc < 0, "argc < 0", 1);
	ERROR_IF_M_C(argc > 0 && argv == NULL, "argc > 0 && argv == NULL", 2);

	ERROR_IF_M_C(global_comline != NULL, "Use CL_Free before reusing CL_Init", 3);
	ERROR_IF_M_C(global_comline_complete != NULL, "Use CL_Free before reusing CL_Init", 3);

	/* table of the command line strings (stop at --) */
	global_comline = SM_StringsAlloc(0);
	JOE;

	for (k = 0; k < argc; k++) {
		ERROR_IF_M_C(argv[k] == NULL, PARAMETER_ERR, 3);

		/* terminate if option "--" */
		if (strcmp(argv[k], "--") == 0) {
			k = argc;
			continue;
		}

		tmp = CL_StringProcessing(argv[k]);
		JOE;
		SM_StringsAddString(global_comline, tmp);
		JOE;
		deallocate(tmp);
		tmp = NULL;
	}

	/* table of the command line strings (does not stop at --) */
	global_comline_complete = SM_StringsCopy(global_comline);
	JOE;

	for (k = global_comline->num; k < argc; k++) {
		ERROR_IF_M_C(argv[k] == NULL, PARAMETER_ERR, 3);
		SM_StringsAddString(global_comline_complete, argv[k]);
		JOE;
	}

	ERROR_HANDLER_BEGIN("CL_Init");
	CL_Free();
	ERROR_HANDLER_END;
	ERROR_END;
}

int4 LU_Verbose(char *format, ...)
{
va_list ap;
int4 n = 0;

	if (CL_Opt('v')) 
      {
       va_start(ap, format);
		n = vprintf(format, ap);
		va_end(ap);
	  }

  return n;
}

SM_strings *CL_GetStrings(int4 start_pos)
{
SM_strings *str = NULL;
int4        k;

	ERROR_IF_M(global_comline == NULL, CL_NO_INIT_MESSAGE);

	str = SM_StringsAlloc(0); JOE;

	for (k = start_pos; k < global_comline->num; k++) {
		if (global_comline->str[k][0] == '-') {
			k = global_comline->num;
			continue;
		}
		SM_StringsAddString(str, global_comline->str[k]);
		JOE;
	}

	ERROR_HANDLER_BEGIN("CL_GetStrings");
	SM_StringsFree(str);
	str = NULL;
	ERROR_HANDLER_END;
	RETURN(str);
}

int4 SM_StringExtractInt(char *str, int4 deb, int4 end)
{
char *str2 = NULL;
int4 res=-1;

   ERROR_IF_V(str == NULL);

   str2 = SM_StringExtract(str, deb, end); JOE;

   res = SM_StringToInt(str2); JOE;

   ERROR_HANDLER("SM_StringExtractInt");

   deallocate(str2);

   RETURN(res);
}

int4 ShortJulianDayFromMonthAndDay(int4 year, int4 m, int4 d)
{
int4 res = -1;

	ERROR_IF_V(d <= 0 || d >= 32);

	res = d;

	switch (m) {  /* fall through switch */
	case 12:
		res += 30;
	case 11:
		res += 31;
	case 10:
		res += 30;
	case 9:
		res += 31;
	case 8:
		res += 31;
	case 7:
		res += 30;
	case 6:
		res += 31;
	case 5:
		res += 30;
	case 4:
		res += 31;
	case 3:
		res += 28;
	case 2:
		res += 31;
	case 1:
		res += 0;
		break;
	default:
		ERROR_M("illegal month value");
	}

	if (LU_YearIsLeap(year) && m > 2)
		res += 1;				/* leap year */

	ERROR_HANDLER_BEGIN("ShortJulianDayFromMonthAndDay");
	res = -1;
	ERROR_HANDLER_END;
	RETURN(res);
}

int4 CL_Sopt(char *str)
{
int4 k;

	k = CL_StringSearch(str);
	JOE;
	ERROR_HANDLER_BEGIN("CL_Sopt");
	k = -1;
	ERROR_HANDLER_END;
	RETURN(k);
}

char *CL_GetStrOpt(char let)
{
char com[3], *res = NULL;

	sprintf(com, "-%c", let);
	res = CL_GetStrSopt(com);
	JOE;
	ERROR_HANDLER("CL_GetStrOpt");
	RETURN(res);
}

int4 SM_StringIsIntegerValue(char *str)
{
char c;
int4 res = 0;

	ERROR_IF_V(str == NULL);

	if ((c = *str++) && ((c >= '0' && c <= '9') || c == '+' || c == '-'))
		res = 1;

	while (res && (c = *str++))
		if (c < '0' || c > '9')
			res = 0;

	ERROR_HANDLER("SM_StringIsIntegerValue");
	RETURN(res);
}

char *CL_GetStrSopt(char *str)
{
int4 k;
char *res = NULL;

	k = CL_Sopt(str);
	JOE;
	ERROR_IF_M1(k == 0, "option %s does not appear", str);
	ERROR_IF_M1(k + 1 >= global_comline->num, "No argument after option %s", str);
	res = StringCopy(global_comline->str[k + 1]);
	JOE;
	ERROR_HANDLER_BEGIN("CL_GetStrSopt");
	deallocate(res);
	res = NULL;
	ERROR_HANDLER_END;
	RETURN(res);
}

int4 SM_StringToInt(char *str)
{
int4    len, res=0;
char    *end;
long int d = 0;

	ERROR_IF_V(str == NULL);

  /* same as 'SM_StringToLongInt' */
	len = strlen(str);
	d = strtol(str, &end, 10);
	ERROR_IF_M2((end - str) < len, "strtol for \"%s\" failed (bad str: \"%s\")", str, end);

  /* conversion in INT4 */

    ERROR_IF_M(d>MAX_INT4,"d>MAX_INT4");
    ERROR_IF_M(d<MIN_INT4,"d<MIN_INT4");

    res = (int4) d;

	ERROR_HANDLER("SM_StringToInt");

    RETURN(res);
}

int4 LU_YearIsLeap(int4 year)
{
	/* if year % 4   == 0 isleap;
	   if year % 100 == 0 !isleap;
	   if year % 400 == 0 isleap;
	 */
	return !(year % 4) && ((year % 100) || !(year % 400));
}
