/** 
 * \file
 * \brief The header file for the tests to check the processing of xrit files. 
 */

/*
 * Copyright 2010, 2011 Stijn Nevens (RMIB)
 * Copyright 2020 Edward Baudrez (RMIB)
 *
 * This file is part of libxrit
 *
 * libxrit is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libxrit is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with libxrit.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TESTBATTERY_H
#define TESTBATTERY_H

#ifdef __cplusplus
extern "C" {
#endif

void TestHritProcessingObjectLinking(int *pReturnValue);

void TestIP_RectangleHasBiggerSide(int *pReturnValue);

void TestIP_IsDefaultRectangle(int *pReturnValue);

void TestIP_RectangleOverlap(int *pReturnValue);

void TestxRITFileDecompress(int *pReturnValue);

void TestHritFillSegmentHeaderFromSegment(int *pReturnValue);

void TestHritSegmentHeadersAreConsistent(int *pReturnValue);

void TestHritSegmentHeadersAreConsistentPointers(int *pReturnValue);

void TestHritFillImageFromSegmentAndHeader(int *pReturnValue);

void TestHritFillImageAndHeaderFromSegment(int *pReturnValue);

void TestHritFillImageAndHeaderFromSegmentPointers(int *pReturnValue);

void TestHritFillImageFromSegment(int *pReturnValue);

void TestHritFillImageFromSegmentPointers(int *pReturnValue);

void TestHritFillImageAndHeaderFromSegments(int *pReturnValue);

void TestHritFillImageAndHeaderFromSegmentsPointers(int *pReturnValue);

void TestHritFillImageAndHeaderFromSegmentsSM_strings(int *pReturnValue);

void TestHritFillImageFromSegments(int *pReturnValue);

void TestHritFillImageFromSegmentsPointers(int *pReturnValue);

void TestHritFillImageFromSegmentsSM_strings(int *pReturnValue);

void TestHritFillPrologueStructureFromPrologue(int *pReturnValue);

void TestHritFillPrologueStructureFromPrologueFile(int *pReturnValue);

void TestHritFillImageAndHeaderFromChannel(int *pReturnValue);

void TestHritFillImageAndHeaderFromChannelPointers(int *pReturnValue);

void TestHritFillImageFromChannel(int *pReturnValue);

void TestHritFillImageFromChannelPointers(int *pReturnValue);

void TestHritConvertSeviriChannelNumberToChannel(int *pReturnValue);

void TestHritFillImageAndHeaderFromBaseDirSatelliteSlotAndChannel(int *pReturnValue);

void TestHritGenerateSlotDirectoryName(int *pReturnValue);

void TestHritGeneratePrologueLocation(int *pReturnValue);

void TestHritFillPrologueStructureFromBaseDirSatelliteSlotAndChannel(int *pReturnValue);

void TestIODCHritGeneratePrologueLocation(int *pReturnValue);

void TestIODCHritFillImageAndHeaderFromBaseDirSatelliteSlotAndChannel(int *pReturnValue);

void TestBattery(int* pReturnValue);

#ifdef __cplusplus
}
#endif

#endif /* TESTBATTERY_H */
