/**
 * \file
 * \brief A testsuite in C to check the processing of xrit files and helperfunctions. 
 */

/*
 * Copyright 2010, 2011 Stijn Nevens (RMIB)
 *
 * This file is part of libxrit
 *
 * libxrit is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libxrit is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with libxrit.  If not, see <http://www.gnu.org/licenses/>.
 */

/* Project headers */

#include <config.h>
#include "testBattery.h"

/* bats library headers */

#ifdef HAVE_RSLIB  /* For use when the full RMIB library is present. The header files here
                      actually tell the extract script what to take from the lib. Also, this allows
                      testing whether a problem is due to the small library or a real problem. */

#include "comline.h" /* command line input */

#else              /* For use when the small RMIB library is to be used */

#include "rmibsmalllib.h"

#endif

int main(int argc, char **argv)
{
    int returnValue = 0; 

    CL_Init(argc, argv); /* initialize command line stuff */

    TestBattery(&returnValue);

    return(returnValue);
};
